def add_one(number):
    '''


    ML2
    for col in cat.columns
    data[col].nunique()
    'count': data[c] .value_counts(),
    'percent': data[c] .value_counts(normalize=True)*100
    sns.countplot(data[col],label="count")
    plt.show()

    # Plot box plots for numerical variables to visualize outliers
    numerical_columns = data.select_dtypes(include=['int64', 'float64']).columns
    print(numerical_columns)
    i=0
    plt.figure(figsize=(15, 10))
    for column in numerical_columns:
    i=i+1
    plt.subplot(8, 4, i)
    sns.boxplot(data=data[column])
    plt.title(column)

    plt.tight_layout()
    plt.show()

    y = df_employee["Attrition"].map({"Yes": 1, "No": 0})  # Convert target to binary format

    df_employee['JobLevel']=df_employee['JobLevel'].astype('object')
    X = pd.get_dummies(df_employee.drop("Attrition", axis=1), drop_first=True)

    # Assuming 'df' is your DataFrame and 'y' is the target variable
    X = df_bank.drop('y', axis=1)  # Features
    y = df_bank['y']  # Target

    # Train a RandomForestClassifier
    model = RandomForestClassifier(random_state=42)
    model.fit(X, y)


    from sklearn.metrics import
    accuracy_score,precision_score.average_precision_score
    ,recall_score,f1_score

    accuracy = accuracy_score(y_test, y_pred)
    print(classification_report(y_test, y_pred))
    print(confusion_matrix(y_test, y_pred))

    feature_importances = pd.Series(model.feature_importances_, index=X.columns)
    feature_importances.sort_values(ascending=False, inplace=True)

    # Print and plot feature importances
    print("Feature Importances:\n")
    print(feature_importances)

    feature_importances.plot(kind='bar', title='Feature Importance', figsize=(10, 6))
    plt.show()



    # Get the coefficients and calculate odds ratios
    coefficients = model.coef_[0]
    odds_ratios = np.exp(coefficients)

    # Create a DataFrame to display features, coefficients, and odds ratios
    feature_summary = pd.DataFrame({

    'Coefficient (β)': coefficients,
    'Odds Ratio (e^β)': odds_ratios
    })

    # Confusion Matrix Calculation
    conf_matrix = confusion_matrix(y_test, y_pred)
    tn, fp, fn, tp = conf_matrix.ravel()

    # Calculate Sensitivity, Specificity, Misclassification Rate, and Accuracy
    sensitivity = tp / (tp + fn)
    specificity = tn / (tn + fp)
    misclassification_rate = (fp + fn) / len(y_test) * 100
    accuracy = accuracy_score(y_test, y_pred) * 100

    # Output the results
    print("Sensitivity (Recall):", sensitivity)
    print("Specificity:", specificity)
    print("Misclassification Rate (%):", misclassification_rate)
    print("Accuracy (%):", accuracy)


    cm = confusion_matrix(y_test, y_pred)
    sns.heatmap(cm, annot=True, fmt="d", cmap="Blues", xticklabels=labels, yticklabels=labels)
    disp = ConfusionMatrixDisplay(confusion_matrix=cm, display_labels=model.classes_)


    y_proba = model.predict_proba(X_test)[:, 1]  # Probabilities for the positive class
    roc_auc = roc_auc_score(y_test, y_proba)
    print(f"ROC AUC Score: {roc_auc:.2f}")

    # Plot the ROC curve
    fpr, tpr, thresholds = roc_curve(y_test, y_proba)
    plt.figure()
    plt.plot(fpr, tpr, color='blue', label=f'ROC Curve (AUC = {roc_auc:.2f})')
    plt.plot([0, 1], [0, 1], color='gray', linestyle='--')  # Diagonal line for random chance
    plt.xlabel('False Positive Rate')
    plt.ylabel('True Positive Rate')
    plt.title('Receiver Operating Characteristic Curve')
    plt.legend(loc='lower right')
    plt.show()


    print("Logistic Regression Coefficients and Odds Ratios:")
    print(feature_summary)

    from sklearn.metrics import log_loss

    # Calculate log-likelihood for the fitted model on the training set
    log_likelihood_fitted = -log_loss(y_train, model.predict_proba(X_train), normalize=False)

    # Calculate log-likelihood for the null model
    # The null model assumes only the intercept (mean probability of y) without any predictors
    y_null = np.full(y_train.shape, y_train.mean())  # Mean probability of y
    log_likelihood_null = -log_loss(y_train, y_null, normalize=False)

    # Calculate McFadden's R-squared
    mcfadden_r_squared = 1 - (log_likelihood_fitted / log_likelihood_null)

    print("McFadden's R-squared:", mcfadden_r_squared)


    cv_scores = cross_val_score(model, X, y, cv=10, scoring='accuracy')

    # Calculate the average accuracy
    average_accuracy = np.mean(cv_scores)

    # Print the results
    print(f"Cross-Validation Scores: {cv_scores}")
    print(f"Average Accuracy: {average_accuracy:.2f}")


    1. LogisticRegression(random_state=42))
    logreg = LogisticRegression(solver='lbfgs')
    2 model = GaussianNB()
    3 knn = KNeighborsClassifier(n_neighbors=5, metric='euclidean')
    4 model = DecisionTreeClassifier(random_state=42)
        decision_tree = DecisionTreeClassifier(random_state=42,max_features = i, max_leaf_nodes=5)
    5 model = RandomForestClassifier(n_estimators = i, random_state=42)

    1. **[ADABoost](#ada)**
    2. **[Gradient Boosting](#gb)**
    3. **[Extreme Gradient Boosting (XGB)](#xgb)**


    # Define the hyperparameter grid
    param_grid = {
    'criterion': ['gini', 'entropy'],              # Criterion for split quality
    'max_depth': [None, 10, 20, 30, 40, 50],       # Maximum depth of the tree
    'min_samples_split': [2, 5, 10, 20]            # Minimum number of samples required to split an internal node
    }

    # Initialize the Decision Tree model
    decision_tree = DecisionTreeClassifier(random_state=42)

    # Perform Grid Search with Cross-Validation
    grid_search = GridSearchCV(estimator=decision_tree, param_grid=param_grid, cv=10, scoring='accuracy')
    grid_search.fit(X, y)

    # Get the best parameters and best score
    best_params = grid_search.best_params_
    best_score = grid_search.best_score_

    # Output the results
    print("Best Hyperparameters:", best_params)
    print("Best Cross-Validated Accuracy:", best_score)
    '''
    return number + 1

